from rocolib.api.components.Component import Component

#ESP3 STACK WITH PWM SERVO FEATHERWING
c = Component()

c.addSubcomponent("boat", "BoatBase", inherit=True)
c.inheritAllInterfaces("boat")

c.addParameter("length", 130, paramType="length")
c.addParameter("width", 90, paramType="length")
c.addParameter("depth", 70, paramType="length")

c.addConstraint(("boat", "boat.length"), "length")
c.addConstraint(("boat", "boat.width"), "width")
c.addConstraint(("boat", "boat.depth"), "depth")

c.addSubcomponent("stack", "StackMount", inherit="stack.length", prefix=None)
c.inheritAllInterfaces("stack")

c.addSubcomponent("batterymount", "BatteryMount", inherit="batterylength", prefix=None)
c.inheritAllInterfaces("batterymount")

c.addSubcomponent("portsplit", "SplitEdge", inherit=True)
c.addConstraint(("portsplit", "toplength"), "length", "(x,)")
c.addConstraint(("portsplit", "botlength"), ("length", "stack.length", "batterylength"), "(x[0]/2 - (x[1]+x[2])/2, x[1], x[2], x[0]/2 - (x[1]+x[2])/2)")
c.addConnection(("portsplit", "botedge1"), ("stack", "leftArmInterface"))
c.addConnection(("batterymount", "leftArmInterface"), ("portsplit", "botedge2"), tabWidth=10)
c.addConnection(("boat", "portedge"), ("portsplit", "topedge0"))

c.addSubcomponent("starsplit", "SplitEdge", inherit=True)
c.addConstraint(("starsplit", "toplength"), "length", "(x,)")
c.addConstraint(("starsplit", "botlength"), ("length", "stack.length", "batterylength"), "(x[0]/2 - (x[1]+x[2])/2, x[2], x[1], x[0]/2 - (x[1]+x[2])/2)")
c.addConnection(("starsplit", "botedge2"), ("stack", "rightArmInterface"), tabWidth=10)
c.addConnection(("batterymount", "rightArmInterface"), ("starsplit", "botedge1"), tabWidth=10)
c.addConnection(("boat", "staredge"), ("starsplit", "topedge0"))
# #
# c.addConstraint(("split0", "botlength"), ("topDistance", "botDistance"), "(x[0]-5, 10, x[1]-5)")
# c.addConstraint(("split1", "botlength"), ("topDistance", "botDistance"), "(x[1]-5, 10, x[0]-5)")
#
# c.addConnection(("boat", "portedge"), ("split0", "topedge0"))
# c.addConnection(("boat", "staredge"), ("split1", "topedge0"))
#

#the length of the both should always be a multiple of the width of the motor
#as of now i will be setting the length to 117 (so that means 9 * width of the motor which is 13)

c.toLibrary("BoatWithStackBattery")
